# Generated automatically from Makefile.in by configure.
# Generated automatically from Makefile.in by configure.
#
# Makefile for kotetu
#



#
# options:
#   LOG_DIRECTCLIENTIPADDRESS    record direct IP-address as clientname
#                                otherwise, scrambled name
#   LOG_LOCALTIME                record local time
#                                otherwise, universal time (UTC)
#	DONT_USE_THREAD_ATTR
#	DO_ACCEPT_LOCK
#		-DLOG_REPORT_CONSOLE \
#	USE_WQUEUE
#
DEFS = -DHAVE_CONFIG_H -DDONT_USE_THREAD_ATTR
LIBS = -lm 
DEBUG = -g -DNDEBUG

### for RedHat 6.x
CFLAGS = $(DEBUG) $(DEFS) \
       -D_XOPEN_SOURCE -D_XOPEN_SOURCE_EXTENDED \
#       -D_POSIX_SOURCE -D_POSIX_C_SOURCE=199506 \
       -D_POSIX_SOURCE \
       -D_REENTRANT -D_THREAD_SAFE

####

RM=rm

# for FreeBSD 4.x
#CC=cc -pthread

####

PGM = kotetuserv hres disk_bench
OPGM = kotetuserv hres kotetuadm chk_sysconf

SERVOBJS = proxy_global.o args.o
COMMONOBJS = http_misc.o msg.o socket.o sigs.o \
    hname.o misc.o url.o sim_stat.o sim_hist.o date.o accept.o 

AOBJS = admin_main.o admin_proxyconfig.o \
        $(SERVOBJS) $(COMMONOBJS)
POBJS = proxy_main.o proxy_report.o proxy_msg.o \
		hcache.o xsk.o parse.o squeue.o sess.o mlist.o dhr.o \
        $(SERVOBJS) $(COMMONOBJS)
DOBJS = disk_bench.o proxy_report.o proxy_msg.o \
		hcache.o xsk.o parse.o squeue.o sess.o mlist.o \
        $(SERVOBJS) $(COMMONOBJS)
ROBJS = hres.o $(COMMONOBJS)

OBJS= $(AOBJS) $(POBJS) $(ROBJS) chk_sysconf.o




usual: $(PGM)

all: $(PGM) $(OPGM)

kotetuserv: $(POBJS)
	$(CC) $(CFLAGS) -o kotetuserv $(POBJS) $(LIBS)

disk_bench: $(DOBJS)
	$(CC) $(CFLAGS) -o disk_bench $(DOBJS) $(LIBS)

hres: $(ROBJS)
	$(CC) $(CFLAGS) -o hres $(ROBJS) $(LIBS)

kotetuadm: $(AOBJS) 
	$(CC) $(CFLAGS) -o kotetuadm $(AOBJS) $(LIBS)

chk_sysconf: chk_sysconf.o
	$(CC) $(CFLAGS) -o chk_sysconf chk_sysconf.o



clean:
	$(RM) -f $(PGM) 
	$(RM) -f $(OBJS)
	$(RM) -f core


###
### dependency
###

$(OBJS): config.h
proxy_main.c proxy_msg.c proxy_report.c sess.c squeue.c: sess.h
proxy_main.c xsk.c xsk_hash.c : xsk.h



