static int prime_box[]  =
    {162059,74941,53479,117431,110581,114083,92431,88463,12113,152623,};
static int prime_box2[] =
    {81611,6287,55381,46027,30949,108061,32573,66739,55547,83389,};
static int prime_box3[] =
    {25087,124769,62297,123377,71453,144497,88397,44257,119183,11317,};
static int prime_box4[] =
    {55967,8287,71341,129293,34259,7607,84191,4721,75557,34259,};

int
calc_hash(unsigned char *b, int *h1, int *h2, int *h3, int *h4)
{
    int l;
    register int sum, c;
    register unsigned char *p;
    register unsigned char q, r;

    sum = 0;

    /*  *p  - focused char
     *  q   - previous char
     *  r   - twice previous char
     */
    
    c = 1;
    p = b;
    q = 127;
    r = 227;
    while(*p) {
#if 1
        sum = sum << 1;
        sum +=  prime_box[((int)*p+c)%10]  + prime_box2[((int)q+*p+c)%10]
            +   prime_box3[((int)r+*p+c)%10] + prime_box4[((int)r+q+*p+c)%10];
#endif
#if 0
        sum = sum << 1;
        sum += *p - ' ' + c;
        if(*p>='0' && *p<='9') {
            sum += prime_box[(q+c+*p)%10] + prime_box2[*p - '0'];
        }
        else {
            sum += prime_box3[(q+*p)%10] + prime_box4[(q+c)%10];
        }
#endif
#if 0
        sum += *p - ' ' + c;
        if(*p>='0' && *p<='9') {
            sum += prime_box[(c+*p)%10] + prime_box2[*p - '0'];
        }
        else {
            sum += - prime_box3[*p%10] - prime_box4[c%10];
        }
#endif
#if 0
        sum += sum % prime_box2[(c+*p)%10];
        sum += q + *p + prime_box4[*p%10] + prime_box3[c%10];
#endif
        q = *p;
        r = q;

        c++;
        p++;
    }

    if(sum<0)
        sum = -sum;

#if 0
    *h1 = sum%radix_h1;
    *h2 = sum%radix_h2;
    *h3 = sum%radix_h3;
    *h4 = sum%radix_h4;
#endif
#if 0
    *h1 = (sum >> 24)        % radix_h1;
    *h2 = (sum >> 16 & 0xff) % radix_h2;
    *h3 = (sum >>  8 & 0xff) % radix_h3;
    *h4 = (sum     & 0xffff) % radix_h4;
#endif
#if 0
    *h1 = (sum >> 24) % radix_h1;
    *h2 = (sum >> 16) % radix_h2;
    *h3 = (sum >>  8) % radix_h3;
    /*
    *h4 = (sum      ) % radix_h4;
    */
    *h4 = (sum >> 11) % radix_h4;
#endif

#if 1
    *h1 = (sum      ) % radix_h1;
    *h2 = (sum >> 15) % radix_h2;
    *h3 = (sum >>  7) % radix_h3;
    *h4 = (sum >> 11) % radix_h4;
#endif

#if 0
Trace("sum %12d -> %3d, %3d, %3d, %5d\n", sum, *h1, *h2, *h3, *h4);
#endif

    return sum % radix_h1;
}

